<?php 

namespace Teknisa\ACL\Controllers;
    
use Zeedhi\Framework\Controller\CrudWithParameterBag;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\Manager;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Teknisa\ACL\Services;
use Doctrine\DBAL\Connection;
use Teknisa\ACL\Util\AclUtilities;
use Teknisa\ACL\Util\Utilities;
use Zeedhi\Framework\DataSource\FilterCriteria;
use Teknisa\ACL\Util\InstanceProvider;





class GrupoOperador extends CrudWithParameterBag { 
    protected $entityManager;

    protected $dataSourceNameArray = array (
        'grupo_operadores' => 'ger02000_grupoOperador',
        'grupo' => 'grupopcont'
    );
    protected $parameterBagColumnsArray = array (
        'grupo_operadores' =>  array('NRORG', 'CDGRUPOPER','NRPERFILACESSO'),
        'grupo' =>  array('NRPERFILACESSO'),
    );
   public function __construct ($crudService, $parameterBag, Manager $dataSourceManager,\Doctrine\ORM\EntityManager $entityManager) {
        $this->crudService       = $crudService;
        $this->parameterBag      = $parameterBag;
        $this->dataSourceManager = $dataSourceManager;
        $this->entityManager = $entityManager;
        
    }
    
    ///find's
    public function findGrupoOperadores(DTO\Request\Filter $request, DTO\Response $response) {
        $this->dataSourceName = $this->dataSourceNameArray['grupo_operadores'];
        $this->parameterBagColumns = $this->parameterBagColumnsArray['grupo_operadores'];
        parent::find($request, $response);
    }
    
    public function SaveGrupo ($rows){
        $rows = $rows->getDataSet()->getRows();
      foreach($rows as $row){
        $params = array(
            ":CDGRUPOPER"=>$row['CDGRUPOPER'],
         	":NRORG" => $row['NRORG'],
         	":NRPERFILACESSO" =>$row['NRPERFILACESSO']
        );
    	$query = $this->entityManager->getConnection()->executeQuery(self::INSERT_GRUPO, $params);
      }
    }
     public function findGrupo(DTO\Request\Filter $request, DTO\Response $response) {
      $this->dataSourceName = $this->dataSourceNameArray['grupo'];
      $this->parameterBagColumns = $this->parameterBagColumnsArray['grupo'];
      $conditions = $request->getFilterCriteria()->getConditions();
      unset($conditions[0]);
      $newRequest = new DTO\Request\Filter(
            new FilterCriteria(
                $request->getFilterCriteria()->getDataSourceName(),
                $conditions,
                $request->getFilterCriteria()->getPage(),
                $request->getFilterCriteria()->getPageSize()
            ),
            $request->getMethod(),
            $request->getRoutePath(),
            $request->getUserId()
        );
        parent::find($newRequest, $response);
    }
    
    public function DeleteGrupo(DTO\Request $request, DTO\Response $response) {
            $rows  = $request->getDataSet()->getRows();
            $this->dataSourceName = $this->dataSourceNameArray['grupo'];
      $this->parameterBagColumns = $this->parameterBagColumnsArray['grupo'];
            parent::delete($request, $response);
        
    }
     
      const INSERT_GRUPO = "
  INSERT INTO GRUPOPCONT (CDGRUPOPER,NRORG,NRPERFILACESSO) VALUES
  ( :CDGRUPOPER,  :NRORG,:NRPERFILACESSO)
	";
	
	public function findGrupoper(DTO\Request\Filter $request, DTO\Response $response) {
        $conditions = $request->getFilterCriteria()->getConditions();
       $conditions = InstanceProvider::getService()->getGrupoOperador()->findGrupoper($conditions);
       $response->addDataSet(new DataSet("grupoper", $conditions));
    }
    
    public function SaveGrupoper($row)
    {  $rows = $row->getDataSet()->getRows();
       $operatorService = InstanceProvider::getService()->getOperator();

        foreach($rows as $row){
        $gropor[]=$row['CDGRUPOPER'];
        $operator['CDOPERADOR']=$row['CDOPERADOR'];
        $nrperfilacesso['NRPERFILACESSO']=isset($row['NRPERFILACESSO']) ? $row['NRPERFILACESSO'] : null;
        }
    $operatorService->SaveGrupoper( $gropor,$operator,$nrperfilacesso);
    }
    
    public function DeleteGrupoper(DTO\Request $request, DTO\Response $response) {
            $rows  = $request->getDataSet()->getRows();
            
            $this->dataSourceName = 'grupoper';
      $this->parameterBagColumns = 'CDOPERADOR';
            parent::delete($request, $response);
        
    }
    
	
}
?>